#include "BeOSReadDir.h"
#include <stdio.h>
#include <Entry.h>
#include <iostream.h>

BeOSReadDir::BeOSReadDir()
{
    m_files = NULL;
    m_fileCount = 0;
    m_currentFile = 0;
    m_path = NULL;
}

BeOSReadDir::BeOSReadDir(char* path)
{
    m_files = NULL;
    m_fileCount = 0;
    m_currentFile = 0;
    m_path = NULL;

    open(path);
}

BeOSReadDir::~BeOSReadDir()
{
	close();
}

void BeOSReadDir::getNext(char *nextPath)
{
	// Eliminate files that start with '.' if possible.
	// This is mostly to eliminate from the list '.' and '..'
	if(m_files[m_currentFile][0] == '.')
	{
		if(hasNext())
		{
			m_currentFile++;
            getNext(nextPath);
			return;		
		}
	}

	// prepend the directory that these files exist in.
	strcpy((char *)nextPath, m_path);
	strcat((char *)nextPath, "/");
	strcat((char *)nextPath, m_files[m_currentFile++]);
}

int BeOSReadDir::hasNext()
{
	return(m_fileCount != -1 && (m_currentFile != m_fileCount));
}

int BeOSReadDir::open(char *path)
{
	BDirectory dir;
	entry_ref ref;
	
	if(m_path != NULL)
	{
		free(m_path);
	}
	
	m_path = (char *)malloc(strlen(path)+1);
    strcpy(m_path, path);

	if(dir.SetTo(m_path) != B_OK)
	{
		m_fileCount = -1;
		return 0;
	}

	m_fileCount = 0;
	
	dir.Rewind();
	
	while(dir.GetNextRef(&ref) != B_ENTRY_NOT_FOUND) {
		m_fileCount++;
	}

	m_files = (char **)malloc(sizeof(char *)*m_fileCount);

	m_currentFile = 0;
	
	dir.Rewind();
	
	while(dir.GetNextRef(&ref) != B_ENTRY_NOT_FOUND) {
			m_files[m_currentFile] = (char *)malloc(strlen(ref.name+1));
			strcpy((char *)m_files[m_currentFile], (char *)ref.name);
			m_currentFile++;
	}
	
	m_currentFile = 0;
	
	if(m_fileCount == 0) m_fileCount = -1; // stops a crash in the destructor, when rom dir is empty.
	
	return(m_fileCount);
}

int BeOSReadDir::close()
{
	if(m_files != NULL && m_fileCount != -1)
	{
		m_fileCount--;
		while(m_fileCount)
		{
			if(m_files[m_fileCount] != NULL)
			{
				free(m_files[m_fileCount]);
			}
			m_fileCount--;
		}
		free(m_files);
		m_files = NULL;
	}
	if(m_path != NULL)
	{
		free(m_path);
		m_path = NULL;
	}
	return 0;
}
